package adaptors;

import net.minecraft.tileentity.TileEntity;

import ic2.api.energy.EnergyNet;
import ic2.api.energy.tile.IEnergySink;
import ic2.api.energy.tile.IEnergySource;

public abstract class TileEntityDelegate extends TileEntity  implements IEnergySink, IEnergySource {
	public TileEntityDelegate(TileEntity parent) {
		worldObj = parent.getWorldObj();
		xCoord = parent.xCoord;
		yCoord = parent.yCoord;
		zCoord = parent.zCoord;
	}

	public abstract void tick();

	@Override
	public int getSinkTier() {
		return Integer.MAX_VALUE;
	}

	@Override
	public int getSourceTier() {
		double energy = getOfferedEnergy();

		return energy > 0 ? EnergyNet.instance.getTierFromPower(energy) : 1;
	}
}
