package enetbridge;

import net.minecraft.tileentity.TileEntity;

import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.eventhandler.EventPriority;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.TickEvent;
import cpw.mods.fml.common.gameevent.TickEvent.Phase;

import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.world.WorldEvent;

public class EventCallback {
	public static void load() {
		if (EnetBridge.hasRf() || EnetBridge.hasMj() || EnetBridge.hasCharge()) {
			EventCallback cb = new EventCallback();

			FMLCommonHandler.instance().bus().register(cb);
			MinecraftForge.EVENT_BUS.register(cb);
		}
	}

	private EventCallback() {
	}

	@SubscribeEvent(priority = EventPriority.HIGH)
	public void onWorldTick(TickEvent.WorldTickEvent event) {
		if (event.phase != Phase.END) return;

		MainLogic.onWorldTickEnd(event.world);
	}

	@SubscribeEvent
	public void onWorldLoad(WorldEvent.Load event) {
		if (FMLCommonHandler.instance().getEffectiveSide().isServer()) {
			@SuppressWarnings("unchecked")
			TrackingList<TileEntity> tl = new TrackingList<TileEntity>(event.world.loadedTileEntityList);
			event.world.loadedTileEntityList = tl;
			MainLogic.setTrackingList(event.world, tl);
		}
	}

	@SubscribeEvent
	public void onWorldUnload(WorldEvent.Unload event) {
		MainLogic.onWorldUnload(event.world);
	}
}
